commit 3411f75ea1cd3d98f77367fc4b0a54871978645d
Author: Andrew Stubbs <ams@codesourcery.com>
Date:   Fri Apr 14 18:05:15 2023

    amdgcn: HardFP divide
    
    Implement FP division using hardware instructions. This replaces both the
    softfp library calls, and the --fast-math inaccurate divsion we had previously.
    
    The GCN architecture does not have a single divide instruction, but it does
    have a number of support instructions designed to make multiply-by-reciprocal
    sufficiently accurate for non-fast-math usage.
    
    gcc/ChangeLog:
    
            * config/gcn/gcn-valu.md (SV_SFDF): New iterator.
            (SV_FP): New iterator.
            (scalar_mode, SCALAR_MODE): Add identity mappings for scalar modes.
            (recip<mode>2): Unify the two patterns using SV_FP.
            (div_scale<mode><exec_vcc>): New insn.
            (div_fmas<mode><exec>): New insn.
            (div_fixup<mode><exec>): New insn.
            (div<mode>3): Unify the two expanders and rewrite using hardfp.
            * config/gcn/gcn.cc (gcn_md_reorg): Support "vccwait" attribute.
            * config/gcn/gcn.md (unspec): Add UNSPEC_DIV_SCALE, UNSPEC_DIV_FMAS,
            and UNSPEC_DIV_FIXUP.
            (vccwait): New attribute.
    
    gcc/testsuite/ChangeLog:
    
            * gcc.target/gcn/fpdiv.c: Remove the -ffast-math requirement.
    
    (cherry picked from commit cfdc45f73c56ad051a53576a4e88675ced2660d4)

diff --git a/gcc/config/gcn/gcn.cc b/gcc/config/gcn/gcn.cc
index a7d278cd2f8..5608d85a1a0 100644
--- a/gcc/config/gcn/gcn.cc
+++ b/gcc/config/gcn/gcn.cc
@@ -5840,6 +5840,7 @@ gcn_md_reorg (void)
       attr_type itype = get_attr_type (insn);
       attr_unit iunit = get_attr_unit (insn);
       attr_delayeduse idelayeduse = get_attr_delayeduse (insn);
+      int ivccwait = get_attr_vccwait (insn);
       HARD_REG_SET ireads, iwrites;
       CLEAR_HARD_REG_SET (ireads);
       CLEAR_HARD_REG_SET (iwrites);
@@ -5917,6 +5918,14 @@ gcn_md_reorg (void)
 	      && ((hard_reg_set_intersect_p
 		   (prev_insn->reads, iwrites))))
 	    nops_rqd = 1 - prev_insn->age;
+
+	  /* Instruction that requires VCC is not written too close before
+	     using it.  */
+	  if (prev_insn->age < ivccwait
+	      && (hard_reg_set_intersect_p
+		  (prev_insn->writes,
+		   reg_class_contents[(int)VCC_CONDITIONAL_REG])))
+	    nops_rqd = ivccwait - prev_insn->age;
 	}
 
       /* Insert the required number of NOPs.  */
diff --git a/gcc/testsuite/gcc.target/gcn/fpdiv.c b/gcc/testsuite/gcc.target/gcn/fpdiv.c
index 7125b6f6ba0..936d39cf98e 100644
--- a/gcc/testsuite/gcc.target/gcn/fpdiv.c
+++ b/gcc/testsuite/gcc.target/gcn/fpdiv.c
@@ -1,5 +1,4 @@
 /* { dg-do run } */
-/* { dg-options "-ffast-math" } */
 
 #include <stdio.h>
 #include <stdlib.h>

